/*******************************************************************

	PKLib	2.0

	The final multicomponent library

	(c) Copyright 19911995 Marco Savegnago IW3FQG 	- All rights reserved

	This software can be freely copied for non-commercial use.

	Thread and ThreadManager	definition

	Autore				Data        Note
	------				----		----

	Marco Savegnago     21/11/93    Scritto e collaudato il modulo

*******************************************************************/

#include <task/tthread.h>
#include <task/ttasker.h>

/*******************************************************************
	Static function
*******************************************************************/

Boolean 	TTasker::isLoaded()
{
	return Boolean(::ctask_resident());
}

TThread::TThread(char *name, word prior, unsigned stacklen )
{
	if(!valid)
		return;
#ifdef __THREAD_SIBILIGNAME
	threadName 	= 	strdup(name);
#else
	threadName 	= 	name;
#endif
	priority	= 	prior;
	stackLen	=	stacklen;
}

TThread::TThread(const TThread& another)
{
	if(!valid)
		return;
#ifdef __THREAD_SIBILIGNAME
	threadName 	= 	strdup(another.threadName);
#else
	threadName 	= 	another.threadName;
#endif
	priority	= 	another.priority;
	stackLen	=	another.stackLen;
}

Boolean TThread::Create()
{
	theTCB = create_task(LNULL, TThread::Execute, LNULL, stackLen, priority, this TN(byteptr(threadName)));

	return valid = Boolean (theTCB != LNULL);
}


void TThread::Execute (void *thread)
{
	((TThread *)thread) -> Run();
}

#ifdef __DEBUG
#	ifdef __CTASK__
#	include <task/tsksup.h>
#	else
#	endif
#endif

#ifdef Use_Template_Collection
static void _startThreads(TThread *theThread, void *)
#else
static void _startThreads(void *theThread, void *)
#endif
{
#ifdef __DEBUG
#	ifdef __CTASK__
#		ifdef Use_Template_Collection
    tprintf("Now start thread %s\n", theThread->getName());
#		else
    tprintf("Now start thread %s\n", ((TThread *)theThread)->getName());
#		endif
#	else
#	endif
#endif
#ifdef Use_Template_Collection
	theThread->Start();
#else
	((TThread *)theThread)->Start();
#endif
}


Boolean TThreadsManager::startThreads()
{
	theThreadsList->forEach(_startThreads, 0);

	return True;
}

#ifdef Use_Template_Collection
static void _stopThreads(TThread *theThread, void *)
#else
static void _stopThreads(void *theThread, void *)
#endif
{
#ifdef __DEBUG
#	ifdef __CTASK__
#		ifdef Use_Template_Collection
    tprintf("Now terminate thread %s\n", theThread->getName());
#		else
    tprintf("Now terminate thread %s\n", ((TThread *)theThread)->getName());
#		endif
#	else
#	endif
#endif
#	ifdef Use_Template_Collection
	theThread->Terminate();
#else
	((TThread *)theThread)->Terminate();
#endif

}

Boolean TThreadsManager::stopThreads()
{
	theThreadsList->forEach(_stopThreads, 0);

	return True;
}


TThreadsManager::~TThreadsManager()
{
#ifdef __DEBUG
#	ifdef __CTASK__
    tputs("TThreadManager dtor called\n");
#	else
#	endif
#endif

#ifndef Use_Template_Collection
	for(int i=0;i<theThreadsList->getCount();i++)
    	delete (TThread*) theThreadsList->at(i);
#endif

	delete	theThreadsList;
}

TThreadsManager::TThreadsManager()
{
	theThreadsList = new TThreadList(5,5);
}

